# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng.tests import BaseTest


class VidasTest(BaseTest):
    MAPPING_CLASS = "vidas"

    def test_resulat(self):
        self.assertResultEqual(
            """
        mtrsl|pi03042200128660|pnLAPLACE_Genevieve|pb11/05/1949|psF|so|si|ci353042202811|rtLYM|rnLYME IgM|tt14:49|td22/04/2013|qlNegatif|qn< 0.02 bli blah|""",
            {
                "353042202811": {
                    "resultats": [
                        {
                            "date": datetime.datetime(2013, 4, 22, 14, 49),
                            "resu": "< 0.02",
                            "test": "LYM",
                        },
                        {
                            "date": datetime.datetime(2013, 4, 22, 14, 49),
                            "resu": "Negatif",
                            "test": "LYMI",
                        },
                    ]
                }
            },
        )

    def test_qc(self):
        self.assertQCEqual(
            """mtrsl|pi|pn|pb|ps|so|si|ciC1 131113-0|rtPBNP|rnVIDAS NT-proBNP|tt12:07|td20/04/2013|ql|qn3981 pg/ml|""",
            [
                {
                    "test": "PBNP",
                    "date": datetime.datetime(2013, 4, 20, 12, 7),
                    "lot": "C1 131113-0",
                    "resu": "3981",
                }
            ],
        )

    def test_order(self):
        self.assertOrderMessageEqual(
            self.WORKLIST_NEW_ADD_DEL,
            """
            mtmpr|pi036666666|pnNYME ANO|pb13/05/2011|psF|so|si|ci123456|rtA|qd1|
            mtmpr|pi036666666|pnNYME ANO|pb13/05/2011|psF|so|si|ci123456|rtB|qd1|""",
        )
